unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ActnList, ToolWin, ComCtrls, Menus, Grids, StdCtrls,
  ExtCtrls,
  calibration;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Ouvrir1: TMenuItem;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    ActionList1: TActionList;
    ImageList1: TImageList;
    Ouvrir: TAction;
    Enregistrer: TAction;
    EnregistrerSous: TAction;
    Quitter: TAction;
    Enregistrer2: TMenuItem;
    Enregistrersous1: TMenuItem;
    N1: TMenuItem;
    Quitter1: TMenuItem;
    Apropos: TAction;
    N2: TMenuItem;
    Apropos1: TMenuItem;
    Nouveau: TAction;
    Ouvrir2: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    TreeViewGPX: TTreeView;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Panel1: TPanel;
    ScrollBarHori: TScrollBar;
    ScrollBarVerti: TScrollBar;
    ImageCarte: TImage;
    ToolButton4: TToolButton;
    ComboScale: TComboBox;
    ChargerCarte: TAction;
    Carte1: TMenuItem;
    Charger1: TMenuItem;
    GPX1: TMenuItem;
    ChargerGPX: TAction;
    Charger2: TMenuItem;
    SaveDialogCal: TSaveDialog;
    OpenDialogMap: TOpenDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    StringGridPoints: TStringGrid;
    TabSheet2: TTabSheet;
    PopupMenuGrid: TPopupMenu;
    Supprimer1: TMenuItem;
    OpenDialogGPX: TOpenDialog;
    LabelProjection: TLabel;
    ComboBoxProj: TComboBox;
    CheckBoxIsotrope: TCheckBox;
    CheckBoxScale: TCheckBox;
    LabelScale: TLabel;
    EditScale: TEdit;
    CheckBoxNord: TCheckBox;
    RadioGroupMethod: TRadioGroup;
    LabelMinimum: TLabel;
    Button1: TButton;
    OpenDialogCal: TOpenDialog;
    Export4pt: TAction;
    CalculateCalib: TAction;
    Calibration1: TMenuItem;
    Calculer1: TMenuItem;
    N3: TMenuItem;
    Exportation4pts1: TMenuItem;
    ExportFull: TAction;
    Exportationcomplte1: TMenuItem;
    ImageListCheckTree: TImageList;
    ToolButton5: TToolButton;
    ExportPicLayer: TAction;
    ExportationPicLayer1: TMenuItem;
    procedure QuitterExecute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure EnregistrerSousExecute(Sender: TObject);
    procedure EnregistrerExecute(Sender: TObject);
    procedure ChargerCarteExecute(Sender: TObject);
    procedure ComboScaleChange(Sender: TObject);
    procedure ScrollBarHoriChange(Sender: TObject);
    procedure ScrollBarVertiChange(Sender: TObject);
    procedure ImageCarteMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImageCarteClick(Sender: TObject);
    procedure StringGridPointsDblClick(Sender: TObject);
    procedure StringGridPointsClick(Sender: TObject);
    procedure Supprimer1Click(Sender: TObject);
    procedure ChargerGPXExecute(Sender: TObject);
    procedure RadioGroupMethodClick(Sender: TObject);
    procedure OuvrirExecute(Sender: TObject);
    procedure Export4ptExecute(Sender: TObject);
    procedure CalculateCalibExecute(Sender: TObject);
    procedure TreeViewGPXClick(Sender: TObject);
    procedure AproposExecute(Sender: TObject);
    procedure ExportFullExecute(Sender: TObject);
    procedure NouveauExecute(Sender: TObject);
    procedure WMMouseWheel(var msg: TMessage); message WM_MOUSEWHEEL;
    procedure ImageCarteMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageCarteMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ExportPicLayerExecute(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    CalibrationProject : TCalibrationProject;
    Center, LastMouse : TPoint;
    Drag : boolean;
    function GetRatio : integer;
    procedure SetScrollBounds;
    procedure DrawMap;
    procedure DrawGPX;
    procedure UpdateRefGrid;
    procedure PrepareMethodProj;
    procedure StoreMethodProj;
    procedure GetMethodProj;
    function NbPointMin : integer;
    procedure CenterOn(X, Y : integer);
    procedure DrawGPXWaypoint(Index : integer);
    procedure DrawGPXTrack(Index : integer);
    procedure DrawGPXRoute(Index : integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  Math,
  donnee, ancetre, // from Convertisseur
  control_dial, carte, reference, drawing_const, gpx_part;

procedure TForm1.WMMouseWheel(var msg: TMessage);
begin
  msg.Result := SendMessage(ComboScale.Handle, msg.msg, msg.wParam, msg.lParam);
end;

procedure TForm1.QuitterExecute(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  if (ClientHeight-582+511>40) and (ClientWidth-862+513-Splitter1.Left+121>40) then
  begin
    ScrollBarVerti.Height := Panel1.Height-ScrollBarHori.Height;
    ScrollBarVerti.SmallChange := ScrollBarVerti.Height div 10;
    ScrollBarVerti.LargeChange := ScrollBarVerti.Height * 9 div 10;
    ScrollBarHori.Width := Panel1.Width-ScrollBarVerti.Width;
    ScrollBarHori.SmallChange := ScrollBarHori.Width div 10;
    ScrollBarHori.LargeChange := ScrollBarHori.Width * 9 div 10;
    ScrollBarVerti.Left := ScrollBarHori.Width; // bug with anchors=akRight (and Vista) so we calculate theposition manually after resizing
    ImageCarte.Picture.Bitmap.Width := ScrollBarHori.Width;
    ImageCarte.Picture.Bitmap.Height := ScrollBarVerti.Height;
    SetScrollBounds;
    DrawMap;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  StringGridPoints.Cells[0,0]:='Nom';
  StringGridPoints.Cells[1,0]:='Erreur / pixel';
  CalibrationProject := TCalibrationProject.Create;
  Drag := false;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if CalibrationProject<>nil then
  begin
    CalibrationProject.Free;
    CalibrationProject:=nil;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if CalibrationProject.Changed then
  begin
    if MessageDlg('Voulez-vous enregistrer les changements du projet?', mtWarning, [mbYes,MbNo], 0)=mrYes then
      EnregistrerExecute(Sender);
  end;
end;

procedure TForm1.EnregistrerSousExecute(Sender: TObject);
var
  Again : boolean;
begin
  if CalibrationProject.CurrentFileName<>'' then
    SaveDialogCal.FileName:=CalibrationProject.CurrentFileName
  else
    if CalibrationProject.ProposedFileName<>'' then
      SaveDialogCal.FileName:=CalibrationProject.ProposedFileName;
  repeat
    Again:=false;
    if SaveDialogCal.Execute then
    begin
      if FileExists(SaveDialogCal.FileName) and
        (MessageDlg('Le fichier existe dj. Voulez-vous le remplacer?', mtWarning, [mbYes,MbNo], 0)=mrNo)
      then
        Again:=true;
      if not Again then
      begin
        try
          StoreMethodProj;
        except
        end;
        CalibrationProject.SaveToFile(SaveDialogCal.FileName);
        Caption := ExtractFileName(CalibrationProject.CurrentFileName) + ' - Calibration';
        Application.Title := Caption;
      end;
    end;
  until not Again;
end;

procedure TForm1.EnregistrerExecute(Sender: TObject);
begin
  if CalibrationProject.CurrentFileName<>'' then
  begin
    try
      StoreMethodProj;
    except
    end;
    CalibrationProject.SaveToFile(CalibrationProject.CurrentFileName);
  end
  else
    EnregistrerSousExecute(Sender);  
end;

procedure TForm1.ChargerCarteExecute(Sender: TObject);
begin
  if OpenDialogMap.Execute then
  begin
    try
      Screen.Cursor := crHourglass;
      CalibrationProject.Map:=TImageCarteBasic.Create(OpenDialogMap.FileName);
    finally
      Screen.Cursor := crDefault;
    end;
    Center.X:=CalibrationProject.Map.Width div 2;
    Center.Y:=CalibrationProject.Map.Height div 2;
    SetScrollBounds;
    DrawMap;
    PrepareMethodProj;
    RadioGroupMethodClick(Sender);
  end;
end;

procedure TForm1.SetScrollBounds;
var
  Ratio : integer;
begin
  if CalibrationProject<>nil then
  begin
    if CalibrationProject.Map=nil then
    begin
      ScrollBarHori.Enabled:=false;
      ScrollBarVerti.Enabled:=false;
    end
    else
    begin
      Ratio:=GetRatio;

      if CalibrationProject.Map.Width div Ratio>ImageCarte.Width then
      begin
        ScrollBarHori.Enabled:=true;
        if (CalibrationProject.Map.Width div Ratio)-ImageCarte.Width<ScrollBarHori.Max
        then
        begin
          // reducing size, wa have to change the position first otherwise
          // position can be changed by the change of max, leading to a side effect
          ScrollBarHori.Position := Center.X div Ratio - ImageCarte.Width div 2;
          ScrollBarHori.Max:=(CalibrationProject.Map.Width div Ratio)-ImageCarte.Width;
        end
        else
        begin
          ScrollBarHori.Max:=(CalibrationProject.Map.Width div Ratio)-ImageCarte.Width;
          ScrollBarHori.Position := Center.X div Ratio - ImageCarte.Width div 2;
        end;
      end
      else
      begin
        ScrollBarHori.Position:=0;
        ScrollBarHori.Enabled:=false;
      end;

      if CalibrationProject.Map.Height div Ratio>ImageCarte.Height then
      begin
        ScrollBarVerti.Enabled:=true;
        if (CalibrationProject.Map.Height div Ratio)-ImageCarte.Height< ScrollBarVerti.Max
        then
        begin
          // reducing size, wa have to change the position first otherwise
          //position can be changed by the change of max, leading to a side effect
          ScrollBarVerti.Position := Center.Y div Ratio - ImageCarte.Height div 2;
          ScrollBarVerti.Max:=(CalibrationProject.Map.Height div Ratio)-ImageCarte.Height;
        end
        else
        begin
          ScrollBarVerti.Max:=(CalibrationProject.Map.Height div Ratio)-ImageCarte.Height;
          ScrollBarVerti.Position := Center.Y div Ratio - ImageCarte.Height div 2;
        end;
      end
      else
      begin
        ScrollBarVerti.Position:=0;
        ScrollBarVerti.Enabled:=false;
      end;
    end;
  end;
end;

procedure TForm1.ComboScaleChange(Sender: TObject);
begin
  SetScrollBounds;
  DrawMap;
end;

procedure TForm1.DrawMap;
var
  Ratio : integer;
  Bitmap : TBitmap;
  I : integer;
begin
  if CalibrationProject<>nil then
  begin
    if CalibrationProject.Map=nil then
    with ImageCarte.Canvas do
    begin
      Pen.Color:=clWhite;
      Brush.Color:=clWhite;
      Rectangle(0, 0, ImageCarte.Width, ImageCarte.Height);
    end
    else
    begin
      Ratio:=GetRatio;
      Bitmap := TBitmap.Create;
      try
        Bitmap.Width:=ImageCarte.Width;
        Bitmap.Height:=ImageCarte.Height;
        Bitmap.PixelFormat:=pf24bit;
        CalibrationProject.Map.Draw(Bitmap,
                  max(Center.X div Ratio - ImageCarte.Width div 2,0),
                  max(Center.Y div Ratio - ImageCarte.Height div 2,0),
                  Ratio);
        for I:=0 to CalibrationProject.NbRefPoint-1 do
          CalibrationProject.Map.DrawRefPoint(Bitmap.Canvas,
                    max(Center.X div Ratio - ImageCarte.Width div 2,0),
                    max(Center.Y div Ratio - ImageCarte.Height div 2,0),
                    Ratio,
                    CalibrationProject.RefPoint[I],
                    DefaultColor);
        ImageCarte.Picture.Assign(Bitmap);
      finally
        Bitmap.Free;
      end;
      if CalibrationProject.Calculated then
        DrawGPX;

    end;
  end;
end;

function TForm1.GetRatio: integer;
var
  S : string;
begin
  S := ComboScale.Text;
  delete(S,length(S),1); // remove %
  result:=round(100/StrToFloat(S));
end;

procedure TForm1.ScrollBarHoriChange(Sender: TObject);
begin
  Center.X:=(ScrollBarHori.Position+ImageCarte.Width div 2)*GetRatio;
  DrawMap;
end;

procedure TForm1.ScrollBarVertiChange(Sender: TObject);
begin
  Center.Y:=(ScrollBarVerti.Position+ImageCarte.Height div 2)*GetRatio;
  DrawMap;
end;

procedure TForm1.ImageCarteMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  Latitude, Longitude : real;
begin
  if Drag then
  begin
    if ScrollBarHori.Enabled then
      ScrollBarHori.Position := LastMouse.X div GetRatio - X;
    if ScrollBarVerti.Enabled then
      ScrollBarVerti.Position := LastMouse.Y div GetRatio - Y;
  end;

  if ScrollBarHori.Enabled then
    LastMouse.X:=(X+ScrollBarHori.Position)*GetRatio
  else
    LastMouse.X:=X*GetRatio;
  if ScrollBarVerti.Enabled then
    LastMouse.Y:=(Y+ScrollBarVerti.Position)*GetRatio
  else
    LastMouse.Y:=Y*GetRatio;

  if (CalibrationProject<>nil) and CalibrationProject.Calculated then
  begin
    CalibrationProject.Pixel2WGS84(LastMouse.X, LastMouse.Y, Latitude, Longitude);
    StatusBar1.SimpleText:=Format('%.6f  %.6f',[Latitude/Pi*180, Longitude/Pi*180]);
  end;
end;

procedure TForm1.ImageCarteClick(Sender: TObject);
var
  NewPoint : TReferencePoint;
begin
  if (CalibrationProject<>nil) and (CalibrationProject.Map<>nil) then
  begin // adding calibration point
    ControlPointDial.PrepareProjections;
    ControlPointDial.Map:=CalibrationProject.Map;
    ControlPointDial.PrepareNewPoint(LastMouse);
    if ControlPointDial.ShowModal=mrOk then
    begin
      NewPoint := TReferencePoint.Create;
      ControlPointDial.Transfert2Point(NewPoint);
      CalibrationProject.AddRefPoint(NewPoint);
      UpdateRefGrid;
      RadioGroupMethodClick(Sender);
    end;
  end;
end;

procedure TForm1.UpdateRefGrid;
var
  I : integer;
begin
  if CalibrationProject.NbRefPoint=0 then
  begin
    StringGridPoints.RowCount := 2;
    StringGridPoints.Cells[0,1]:='';
    StringGridPoints.Cells[1,1]:='';
  end
  else
    StringGridPoints.RowCount:=CalibrationProject.NbRefPoint+1;
  StringGridPoints.FixedRows:=1;
  for I:=0 to CalibrationProject.NbRefPoint-1 do
  begin
    StringGridPoints.Cells[0,I+1]:=(CalibrationProject.RefPoint[I] as TReferencePoint).Name;
    if CalibrationProject.Calculated then
      StringGridPoints.Cells[1,I+1]:=FloatToStrF(
         (CalibrationProject.RefPoint[I] as TReferencePoint).ErrorDistance,
         ffFixed, 4,2)
    else
      StringGridPoints.Cells[1,I+1]:='';
  end;
  DrawMap;
end;

procedure TForm1.StringGridPointsDblClick(Sender: TObject);
var
  ACol, ARow : integer;
  P : TPoint;
begin
  if (CalibrationProject<>nil) and (CalibrationProject.Map<>nil) then
  begin
    GetCursorPos(P);
    P := StringGridPoints.ScreenToClient(P);
    StringGridPoints.MouseToCell(P.X, P.Y, ACol, ARow);
    if (ARow>0) and (ARow<=CalibrationProject.NbRefPoint) then
    begin
      ControlPointDial.PrepareProjections;
      ControlPointDial.Map:=CalibrationProject.Map;
      ControlPointDial.PrepareOldPoint(CalibrationProject.RefPoint[ARow-1]);
      if ControlPointDial.ShowModal=mrOk then
      begin
        ControlPointDial.Transfert2Point(CalibrationProject.RefPoint[ARow-1]);
        UpdateRefGrid;
        RadioGroupMethodClick(Sender);
      end;
    end;
  end;
end;

procedure TForm1.StringGridPointsClick(Sender: TObject);
var
  ACol, ARow : integer;
  P : TPoint;
begin
  if (CalibrationProject<>nil) and (CalibrationProject.Map<>nil) then
  begin
    DrawMap;
    GetCursorPos(P);
    P := StringGridPoints.ScreenToClient(P);
    StringGridPoints.MouseToCell(P.X, P.Y, ACol, ARow);
    if (ARow>0) and (ARow<=CalibrationProject.NbRefPoint) then
    begin
      CenterOn(CalibrationProject.RefPoint[ARow-1].XPixel, CalibrationProject.RefPoint[ARow-1].YPixel);
      CalibrationProject.Map.DrawRefPoint(ImageCarte.Canvas,
                  max(Center.X div GetRatio - ImageCarte.Width div 2,0),
                  max(Center.Y div GetRatio - ImageCarte.Height div 2,0),
                  GetRatio,
                  CalibrationProject.RefPoint[ARow-1],
                  HighLightColor);
    end;
  end;
end;

procedure TForm1.Supprimer1Click(Sender: TObject);
var
  ACol, ARow : integer;
  P : TPoint;
begin
  if (CalibrationProject<>nil) and (CalibrationProject.Map<>nil) then
  begin
    GetCursorPos(P);
    P := StringGridPoints.ScreenToClient(P);
    StringGridPoints.MouseToCell(P.X, P.Y, ACol, ARow);
    if (ARow>0) and (ARow<=CalibrationProject.NbRefPoint) then
    begin
      if MessageDlg(Format('Voulez-vous supprimer le point %s?',[CalibrationProject.RefPoint[ARow-1].Name]),mtWarning,[mbOk, mbCancel],0)=mrOk then
      begin
        CalibrationProject.DeleteRefPoint(ARow-1);
        UpdateRefGrid;
        DrawMap;
        RadioGroupMethodClick(Sender);
      end;
    end
    else
      ShowMessage('Pas de point  supprimer ici');
  end;
end;

procedure TForm1.ChargerGPXExecute(Sender: TObject);
var
  Error_Msg, Warning_Msg : string;
  Succes : boolean;
  MyTreeNode1 : TTreeNode;
  I : integer;
begin
  if OpenDialogGPX.Execute then
  begin
    if FileExists(OpenDialogGPX.FileName) then
    begin
      Application.ProcessMessages;
      Screen.Cursor:=crHourGlass;
      TreeViewGPX.Items.Clear;
      GPXData.Clear;
      LoadGPXFromFile(OpenDialogGPX.FileName, false, Error_Msg, Warning_Msg, Succes);
      Screen.Cursor:=crDefault;
      if Succes then
      begin
        if Warning_Msg<>'' then
          if MessageDlg('Il y a des avertissements. Voulez-vous les voir?',mtWarning, [mbYes,mbNo],0)=mrYes then
            ShowMessage(Warning_Msg);
        with TreeViewGPX.Items do
        begin
          if GPXData.NbWayPoints>0 then
          begin
            MyTreeNode1 := Add(nil, 'Waypoints');
            for I:=0 to GPXData.NbWayPoints-1 do
              AddChild(MyTreeNode1,UTF8ToAnsi(GPXData.WayPoints[I].Name)).StateIndex := 1;
            MyTreeNode1.StateIndex:=1;
          end
          else
            MyTreeNode1 := nil;
          if GPXData.NbRoutes>0 then
          begin
            MyTreeNode1 := Add(MyTreeNode1, 'Routes');
            for I:=0 to GPXData.NbRoutes-1 do
              AddChild(MyTreeNode1,UTF8ToAnsi(GPXData.Routes[I].Name)).StateIndex := 1;
            MyTreeNode1.StateIndex:=1;
          end;
          if GPXData.NbTracks>0 then
          begin
            MyTreeNode1 := Add(MyTreeNode1, 'Traces');
            for I:=0 to GPXData.NbTracks-1 do
              AddChild(MyTreeNode1,UTF8ToAnsi(GPXData.Tracks[I].Name)).StateIndex := 1;
            MyTreeNode1.StateIndex:=1;
          end;
        end;
      end
      else
      begin
        if MessageDlg('chec  la lecture. Voulez-vous voir les erreurs?',mtError, [mbYes,mbNo],0)=mrYes then
            ShowMessage(Error_Msg);
      end;
      DrawMap;
    end
    else
      ShowMessageFmt('Le fichier %s n''existe pas.',[OpenDialogGPX.FileName]);
  end;
end;

function TForm1.NbPointMin : integer;
// calculating the number of reference points needed for performing the calibration
begin
  Result := 0;
  case RadioGroupMethod.ItemIndex of
    0 : begin // affine
      if CheckBoxIsotrope.Checked then
      begin
        if CheckBoxNord.Checked and CheckBoxScale.Checked then
          Result := 1
        else
          Result := 2;
      end
      else
        Result := 3;
    end;
    1 : Result := 4; // homographic
    2 : Result := 6; // quadratic
  end;
end;

procedure TForm1.RadioGroupMethodClick(Sender: TObject);
// updating display
var
  NbPoint : integer;
begin
  LabelProjection.Enabled:=(RadioGroupMethod.ItemIndex=0);
  if RadioGroupMethod.ItemIndex<>0 then
    ComboBoxProj.ItemIndex:=0;
  ComboBoxProj.Enabled:=(RadioGroupMethod.ItemIndex=0);
  CheckBoxNord.Enabled:=(RadioGroupMethod.ItemIndex=0) and (ComboBoxProj.ItemIndex>0) and CheckBoxIsotrope.Checked;
  if not CheckBoxNord.Enabled then
    CheckBoxNord.Checked:=false;
  CheckBoxIsotrope.Enabled:=(RadioGroupMethod.ItemIndex=0);
  if not CheckBoxIsotrope.Enabled then
    CheckBoxIsotrope.Checked:=false;
  CheckBoxScale.Enabled:=(RadioGroupMethod.ItemIndex=0) and CheckBoxIsotrope.Checked;
  if not CheckBoxScale.Enabled then
    CheckBoxScale.Checked:=false;
  LabelScale.Enabled:=(RadioGroupMethod.ItemIndex=0) and CheckBoxIsotrope.Checked and CheckBoxScale.Checked;
  EditScale.Enabled:=(RadioGroupMethod.ItemIndex=0) and CheckBoxIsotrope.Checked and CheckBoxScale.Checked;

  NbPoint:=NbPointMin;
  if NbPoint=1 then
    LabelMinimum.Caption:='1 point minimum'
  else
    LabelMinimum.Caption:=Format('%d points minimum',[NbPoint]);

  if (CalibrationProject<>nil) and (CalibrationProject.Map<>nil) then
  begin
    if NbPoint>CalibrationProject.NbRefPoint then
      LabelMinimum.Font.Color:=clRed
    else
    begin
      if NbPoint<CalibrationProject.NbRefPoint-1 then
        LabelMinimum.Font.Color:=clGreen
      else
        LabelMinimum.Font.Color:=clWindowText;
    end;
  end
  else
    LabelMinimum.Font.Color:=clBtnFace;


// automatic calculation
  try
    StoreMethodProj;
    CalibrationProject.Calculate;
    UpdateRefGrid;
  except
  end;

end;

procedure TForm1.PrepareMethodProj;
// prepare the projection Combobox (i.e. fill the items)
var
  I, Previous : integer;
begin
  if Donnees<>nil then
  begin
    Previous:=ComboBoxProj.ItemIndex;
    ComboBoxProj.Items.Clear;
    ComboBoxProj.Items.Add('Inconnue');
    for I:=0 to Donnees.NbProjection-1 do
      ComboBoxProj.Items.Add((Donnees.LesProjection[I] as TAncetre).Nom);
    ComboBoxProj.ItemIndex:=Previous;
  end;
end;

procedure TForm1.GetMethodProj;
// transfert the data from CalibrationProject to the GUI interface
var
  Old_Method : TMethod;
begin
  Old_Method := CalibrationProject.Method;
  with Old_Method do
  begin
    RadioGroupMethod.ItemIndex := Method;
    if UnknownProjection then
      ComboBoxProj.ItemIndex:=0
    else
      ComboBoxProj.ItemIndex := Projection +1;
    CheckBoxIsotrope.Checked := Isotrop;
    CheckBoxNord.Checked := Nord;
    CheckBoxScale.Checked := knownScale;
    if knownScale then
      EditScale.Text:=FloatToStrF(Scale,ffFixed,10,3);
  end;
end;

procedure TForm1.StoreMethodProj;
// transfert the data from GUI interface to the CalibrationProject
begin
  with CalibrationProject.Method do
  begin
    CalibrationProject.Changed:=true;
    Method := RadioGroupMethod.ItemIndex;
    UnknownProjection := (ComboBoxProj.ItemIndex=0);
    if not UnknownProjection then
      Projection := ComboBoxProj.ItemIndex-1;
    Nord :=CheckBoxNord.Checked;
    Isotrop := CheckBoxIsotrope.Checked;
    knownScale := CheckBoxScale.Checked;
    if knownScale then
      try
        Scale := StrToFloat(EditScale.Text);
      except
        EditScale.SetFocus;
        Raise EConvertError.Create('L''chelle est incorrecte, exemple 14.25');
      end;
  end;
end;

procedure TForm1.OuvrirExecute(Sender: TObject);
begin
  if OpenDialogCal.Execute then
  begin
    if not FileExists(OpenDialogCal.FileName) then
      ShowMessage(Format('Le fichier %s n''existe pas',[OpenDialogCal.FileName]))
    else
    begin
      NouveauExecute(sender);

      try
        Screen.Cursor := crHourglass;
        CalibrationProject.LoadFromFile(OpenDialogCal.FileName);
        Caption := ExtractFileName(CalibrationProject.CurrentFileName) + ' - Calibration';
        Application.Title := Caption;
      finally
        Screen.Cursor := crDefault;
      end;

      Center.X:=CalibrationProject.Map.Width div 2;
      Center.Y:=CalibrationProject.Map.Height div 2;
      SetScrollBounds;
      DrawMap;
      PrepareMethodProj;
      GetMethodProj;
      RadioGroupMethodClick(Sender);
      UpdateRefGrid;
    end;
  end;
end;

procedure TForm1.Export4ptExecute(Sender: TObject);
begin
  if not CalibrationProject.Calculated then
    ShowMessage('Calculez la calibration avant d''exporter')
  else
    CalibrationProject.Extrapole4pt(ChangeFileExt(CalibrationProject.CurrentFileName,'.map'));
end;

procedure TForm1.CalculateCalibExecute(Sender: TObject);
var
  I : integer;
  SigmaError, MaxError, PtError, S1, S2, Rot : real;
begin
  if NbPointMin>CalibrationProject.NbRefPoint then
    ShowMessage('Pas assez de points de rfrence pour calculer la calibration')
  else
  begin
    try
      StoreMethodProj;
      CalibrationProject.Calculate;

      SigmaError:=0;
      MaxError:=0;
      for I:=0 to CalibrationProject.NbRefPoint-1 do
      begin
  //      PtError:=CalibrationProject.Error_Pixel(I);
        PtError:=CalibrationProject.Error_Metric(I);
        SigmaError:=SigmaError+PtError;
        if PtError>MaxError then
          MaxError:=PtError;
      end;

      ShowMessage(Format('Erreur moyenne %.2f m ; erreur max %.2f m',
          [SigmaError/CalibrationProject.NbRefPoint, MaxError]));

      CalibrationProject.Scales(S1, S2, Rot);
      ShowMessage(Format('chelle moyenne %.3f m/pixel ; asymtrie %.2f %% ; rotation %.1f ',[(S1+s2)/2, abs((S1-S2)/S1*100),Rot/Pi*180]));

      UpdateRefGrid;
    except
      CalibrationProject.Calculated := false;
      ShowMessage('chec de la calibration. Problme de rpartition des points?');
    end;
  end;
end;

procedure TForm1.TreeViewGPXClick(Sender: TObject);
var
  TreeNode : TTreeNode;
  X, Y : real;
  P : TPoint;
  I : integer;
  ExistTrue, ExistFalse : boolean;
begin
  GetCursorPos(P);
  P := TreeViewGPX.ScreenToClient(P);
  TreeNode := TreeViewGPX.GetNodeAt(P.X, P.Y);

  if (TreeNode<>nil) and (htOnStateIcon in TreeViewGPX.GetHitTestInfoAt(P.X,P.Y)) then
  begin
    if TreeNode.Level=0 then
    begin  // parent treenode
      case TreeNode.StateIndex of
        -1, 0, 1 : begin
          TreeNode.StateIndex := 2;  // unckecked to checked
          for I:=0 to TreeNode.Count-1 do // checking all childs
            TreeNode.Item[I].StateIndex:=2;
        end;
        2, 3 : begin // checked or middle checked to unchecked
          TreeNode.StateIndex := 1;
          for I:=0 to TreeNode.Count-1 do // unchecking all childs
            TreeNode.Item[I].StateIndex:=1;
        end;
      end;
    end
    else
    begin // child treenode
      case TreeNode.StateIndex of
        -1, 0, 1 : begin // unckecked to checked
          TreeNode.StateIndex := 2;
          if (CalibrationProject<>nil) and CalibrationProject.Calculated and (TreeNode.Parent.Text='Waypoints') then
          begin // centering on the selected waypoint
            CalibrationProject.WGS842Pixel(GPXData.WayPoints[TreeNode.Index].Latitude/180*Pi,
                                           GPXData.WayPoints[TreeNode.Index].Longitude/180*Pi,
                                           X,Y);
            CenterOn(round(X), round(Y));
          end;
        end;
        2 : TreeNode.StateIndex := 1;         // checked to unchecked
      end;
      // adjusting parent node according the his childs
      ExistTrue:=false; ExistFalse := false;
      TreeNode:=TreeNode.Parent;
      for I:=0 to TreeNode.Count-1 do
        if TreeNode.Item[I].StateIndex=2 then
          ExistTrue:=true
        else
          ExistFalse:=true;
      if ExistTrue then
        if ExistFalse then
          TreeNode.StateIndex:=3 // middle checked
        else
          TreeNode.StateIndex:=2 // checked
      else
        TreeNode.StateIndex:=1; // unchecked

    end;
    DrawMap;
  end;
end;

procedure TForm1.DrawGPX;
var
  TreeNode, Child : TTreeNode;
  S : string;
  I, J : integer;
begin
  assert((CalibrationProject<>nil) and CalibrationProject.Calculated,'CalibrationProject not Calculated in TForm1.DrawGPX');

  for I:=0 to TreeViewGPX.Items.Count-1 do
  begin
    TreeNode := TreeViewGPX.Items[I];
    S:=TreeNode.Text;

    Child := TreeNode.getFirstChild;
    J := 0;

    while Child<>nil do
    begin
      if Child.StateIndex=2 then
      begin
        if S='Waypoints' then
          DrawGPXWaypoint(J);
        if S='Traces' then
          DrawGPXTrack(J);
        if S='Routes' then
          DrawGPXRoute(J);
      end;
      Child := Child.getNextSibling;
//      Child := TreeNode.GetNextChild(Child);
      inc(J);
    end;


{    for J:=0 to TreeNode.Count-1 do
     if TreeNode.Item[J].StateIndex=2 then
    begin
      if S='Waypoints' then
        DrawGPXWaypoint(J);
      if S='Traces' then
        DrawGPXTrack(J);
      if S='Routes' then
        DrawGPXRoute(J);
    end; }
  end;
end;


procedure TForm1.CenterOn(X, Y : integer);
begin
  if ScrollBarHori.Enabled then
    ScrollBarHori.Position:=min(X div GetRatio - ImageCarte.Width div 2,
      ScrollBarHori.Max);
  if ScrollBarVerti.Enabled then
    ScrollBarVerti.Position:=min(Y div GetRatio - ImageCarte.Height div 2,
      ScrollBarVerti.Max);
end;

procedure TForm1.DrawGPXWaypoint(Index : integer);
var
  X, Y : real;
begin
  CalibrationProject.WGS842Pixel(GPXData.WayPoints[Index].Latitude/180*Pi,
                                 GPXData.WayPoints[Index].Longitude/180*Pi,
                                 X,Y);
  CalibrationProject.Map.DrawPoint(ImageCarte.Canvas,
               Point(round(X/GetRatio-ScrollBarHori.Position), round(Y/GetRatio-ScrollBarVerti.Position)),
               GPXData.WayPoints[Index].Name, clRed);
end;

procedure TForm1.DrawGPXTrack(Index : integer);
var
  I, J : integer;
  X, Y, Xe, Ye : real;
begin
  with GPXData.Tracks[Index] do
  begin
    for I:=0 to NbTrackSegs-1 do
    with TrackSegs[I] do
    begin
      CalibrationProject.WGS842Pixel(WayPoints[0].Latitude/180*Pi,
                                     WayPoints[0].Longitude/180*Pi,
                                     X,Y);
      for J:=1 to TrackSegs[I].NbWaypoints-1 do
      begin
        CalibrationProject.WGS842Pixel(WayPoints[J].Latitude/180*Pi,
                                       WayPoints[J].Longitude/180*Pi,
                                       Xe,Ye);
        CalibrationProject.Map.DrawSegment(ImageCarte.Canvas,
                     Point(round(X/GetRatio-ScrollBarHori.Position), round(Y/GetRatio-ScrollBarVerti.Position)),
                     Point(round(Xe/GetRatio-ScrollBarHori.Position), round(Ye/GetRatio-ScrollBarVerti.Position)),
                     clRed);
        X:=Xe; Y:=Ye;
      end;
    end;
  end;
end;

procedure TForm1.DrawGPXRoute(Index : integer);
var
  I : integer;
  X, Y, Xe, Ye : real;
begin
  with GPXData.Routes[Index] do
   if NbWaypoints>0 then //check that the route is not empty
  begin
    CalibrationProject.WGS842Pixel(WayPoints[0].Latitude/180*Pi,
                                   WayPoints[0].Longitude/180*Pi,
                                   X,Y);
    CalibrationProject.Map.DrawPoint(ImageCarte.Canvas,
                 Point(round(X/GetRatio-ScrollBarHori.Position), round(Y/GetRatio-ScrollBarVerti.Position)),
                 WayPoints[0].Name, clRed);
    for I:=1 to NbWaypoints-1 do
    begin
      CalibrationProject.WGS842Pixel(WayPoints[I].Latitude/180*Pi,
                                     WayPoints[I].Longitude/180*Pi,
                                     Xe,Ye);
      CalibrationProject.Map.DrawSegment(ImageCarte.Canvas,
                   Point(round(X/GetRatio-ScrollBarHori.Position), round(Y/GetRatio-ScrollBarVerti.Position)),
                   Point(round(Xe/GetRatio-ScrollBarHori.Position), round(Ye/GetRatio-ScrollBarVerti.Position)),
                   clRed);
      CalibrationProject.Map.DrawPoint(ImageCarte.Canvas,
                   Point(round(Xe/GetRatio-ScrollBarHori.Position), round(Ye/GetRatio-ScrollBarVerti.Position)),
                   WayPoints[I].Name, clRed);
      X:=Xe; Y:=Ye;
    end;
  end;
end;

procedure TForm1.AproposExecute(Sender: TObject);
begin
  ShowMessage('Calibration par ric Sibert (http://eric.sibert.fr). Licence GNU GPL 2');
end;

procedure TForm1.ExportFullExecute(Sender: TObject);
begin
  if not CalibrationProject.Calculated then
    ShowMessage('Calculez la calibration avant d''exporter')
  else
    CalibrationProject.ExportOzi(ChangeFileExt(CalibrationProject.CurrentFileName,'.map'));
end;

procedure TForm1.NouveauExecute(Sender: TObject);
begin
  if CalibrationProject.Changed then
  begin
    if MessageDlg('Voulez-vous enregistrer les changements du projet?', mtWarning, [mbYes,MbNo], 0)=mrYes then
      EnregistrerExecute(Sender);
  end;

  CalibrationProject.Free;
  CalibrationProject:=TCalibrationProject.Create;
  Caption := 'Calibration';
  Application.Title := Caption;

  SetScrollBounds;
  DrawMap;
  UpdateRefGrid;
end;

procedure TForm1.ImageCarteMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then
  begin
    Drag := true;
    Screen.Cursor := crSizeAll;
  end;
end;

procedure TForm1.ImageCarteMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbRight then
  begin
    Drag := false;
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.ExportPicLayerExecute(Sender: TObject);
begin
  if not CalibrationProject.Calculated then
    ShowMessage('Calculez la calibration avant d''exporter')
  else
    CalibrationProject.ExportPicLayer(ChangeFileExt(CalibrationProject.CurrentFileName,'.cal'));

end;

end.
