unit matrices;

interface

type
  TMatrice4 = array[1..4,1..4] of real;
  TColonne4 = array[1..4] of real;


procedure Zero4(var Matrice4 : TMatrice4; var Colonne4 : TColonne4);
function SolveLinear4(Matrice4 : TMatrice4; Colonne4 : TColonne4) : TColonne4;

implementation

procedure Zero4(var Matrice4 : TMatrice4; var Colonne4 : TColonne4);
var
  I, J : integer;
begin
  for I:=1 to 4 do
  begin
    Colonne4[I]:=0;
    for J:=1 to 4 do
      Matrice4[I,J]:=0;
  end;
end;

function SolveLinear4(Matrice4 : TMatrice4; Colonne4 : TColonne4) : TColonne4;
// resolution par le pivot de Guass
const
  N : integer = 4;
var
  I, J, K : integer;
  PivotMax, Swap : real;
  IMax : integer;
begin
  for I:=1 to N do
  begin
    // recherche du pivot max
    PivotMax:=abs(Matrice4[I,I]);
    Imax:=I;
    for J:=I+1 to N do
    begin
      if PivotMax<abs(Matrice4[I,J]) then
      begin
        PivotMax:=abs(Matrice4[I,J]);
        Imax:=J;
      end;
    end;
    PivotMax:=Matrice4[I,Imax];

    // rcuprartion du pivot max (et normalisation)
    if Imax<>I then
    begin
      for J:=I to N do
      begin
        Swap:=Matrice4[J,I];
        Matrice4[J,I]:=Matrice4[J,Imax]/PivotMax;
        Matrice4[J,Imax]:=Swap;
      end;
      Swap:=Colonne4[I];
      Colonne4[I]:=Colonne4[Imax]/PivotMax;
      Colonne4[Imax]:=Swap;
    end
    else
    begin
      for J:=I+1 to N do
        Matrice4[J,I]:=Matrice4[J,I]/PivotMax;
      Colonne4[I]:=Colonne4[I]/PivotMax;  
    end;

    // limination des coefficients infrieurs
    for J:=I+1 to N do
    begin
      PivotMax:=Matrice4[I,J];
      for K:=I+1 to N do
        Matrice4[K,J]:=Matrice4[K,J]-PivotMax*Matrice4[K,I];
      Colonne4[J]:=Colonne4[J]-PivotMax*Colonne4[I];
    end;
  end;

  // limination en remontant
  for I:=N downto 2 do
  begin
    for J:=I-1 downto 1 do
      Colonne4[J]:=Colonne4[J]-Matrice4[I,J]*Colonne4[I];
  end;

  result:=Colonne4;

end;

end.
